package org.jboss.jbpm.webapp.controller;

import javax.enterprise.inject.Model;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;

import org.jboss.jbpm.webapp.service.KBaseService;
import org.jboss.jbpm.webapp.service.Runner;

// The @Model stereotype is a convenience mechanism to make this a request-scoped bean that has an
// EL name
// Read more about the @Model stereotype in this FAQ:
// http://sfwk.org/Documentation/WhatIsThePurposeOfTheModelAnnotation
@Model
public class Controller
{
   @Inject
   private FacesContext facesContext;

   @Inject
   private KBaseService kBaseService;

   @Inject
   Runner runner;

   public void runProcess()
   {
      try
      {
         runner.runIt();
         facesContext.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, "Process was run!", "Complete!"));
      }
      catch (Exception e)
      {
         facesContext.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Uh oh!", "Something happened"));
         e.printStackTrace();
      }
   }

   public void readKnowledgeBase()
   {
      try
      {
         kBaseService.readKnowledgeBase();
         facesContext.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, "Done reading!", "Complete!"));
      }
      catch (Exception e)
      {
         facesContext.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Uh oh!", "Something happened"));
      }
   }
}
