package org.jboss.jbpm.webapp.service;

import javax.enterprise.context.ApplicationScoped;

import org.drools.KnowledgeBase;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.io.ResourceFactory;
import org.drools.io.impl.UrlResource;

@ApplicationScoped
public class KBaseService
{
   private static final String URL = "http://localhost:8080/drools-guvnor/org.drools.guvnor.Guvnor/package/testPackage/LATEST";
   private KnowledgeBase kbase = null;

   public KnowledgeBase getKnowlegdeBase() throws Exception
   {
      if (kbase == null)
      {
         readKnowledgeBase();
      }
      return kbase;
   }

   /**
    * Rereads the knowledge base from Guvnor
    * 
    * @throws Exception
    */
   public void readKnowledgeBase() throws Exception
   {
      UrlResource resource = (UrlResource) ResourceFactory.newUrlResource(URL);
      resource.setBasicAuthentication("enabled");
      resource.setUsername("guest");
      resource.setPassword("guest");

      KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
      kbuilder.add(resource, ResourceType.PKG);

      kbase = kbuilder.newKnowledgeBase();
      System.out.println("Done reading knowledge base.");
   }
}
