package org.jboss.jbpm.webapp.service;

import java.util.HashMap;
import java.util.Map;

import javax.ejb.Singleton;
import javax.inject.Inject;
import javax.inject.Named;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.persistence.jpa.JPAKnowledgeService;
import org.drools.runtime.Environment;
import org.drools.runtime.EnvironmentName;
import org.drools.runtime.StatefulKnowledgeSession;
import org.jboss.jbpm.webapp.model.Person;
import org.jbpm.process.audit.JPAWorkingMemoryDbLogger;

@Singleton
@Named
public class Runner
{
   @Inject
   private KBaseService kbaseService;

   @PersistenceUnit(unitName = "jbpm")
   private EntityManagerFactory emf;

   public void runIt()
   {
      try
      {
         KnowledgeBase kbase = kbaseService.getKnowlegdeBase();

         Environment env = KnowledgeBaseFactory.newEnvironment();
         env.set(EnvironmentName.ENTITY_MANAGER_FACTORY, emf);

         // create a new knowledge session that uses JPA to store the runtime
         // state
         StatefulKnowledgeSession ksession = JPAKnowledgeService.newStatefulKnowledgeSession(kbase, null, env);
         JPAWorkingMemoryDbLogger logger = new JPAWorkingMemoryDbLogger(ksession);

         Map<String, Object> params = new HashMap<String, Object>();
         Person p = new Person("Maciej Swiderski");
         params.put("person", p);
         ksession.startProcess("com.sample.script", params);
      }
      catch (Throwable t)
      {
         t.printStackTrace();
      }
   }
}
